#include <stdio.h>
#include <stdlib.h>

#include "memmap.h"
#include "memlock.h"

int main( int argc, char **argv)
{
    int rc, i;
    int *a;
    int sum;
    mappedRegion reg;
    MEMLOCK s;

    rc = memmap( "xxxmapfilexxx", 12345, 200*sizeof(int), &reg);
    if (rc != 0) {
        printf( "memmap failed, rc = %d\n", rc);
        exit(1);
    }
    
    a = (int *)memGetAddr( &reg);
    if (200 > memGetLength( &reg)) {
        printf( "mapped region too small\n");
        exit(1);
    }

    if (memLockOpen( 12345, & s) < 0) {
        printf( "memLockOpen failed\n");
        exit(1);
    }

    memLock(s);
    for (i=0; i<200; ++i) {
        if (i%10 == 0) printf("\n");
        printf( "%6d", a[i]);
    }

    /* compute sum and compare it with a[199] */
    for (i=0, sum=0; i<199; ++i) {
        sum += a[i];
    }
    printf("\n Summe = %d\n", sum);
    if (sum != a[199]) printf( " *** Fehler, %d != %d\n", sum, a[199]);
    memUnlock(s);

    memunmap( &reg);
}
